<?php

### Created 2002-03-30, by Thomas Kaeser - tkaeser@mail.com ###


//----------------- calculates EAN13/UPC-A check digit -------

function CheckDigit($list)	{
	
	$evensum=$list[0]+$list[2]+$list[4]+$list[6]+$list[8]+$list[10];
	$oddsum=$list[1]+$list[3]+$list[5]+$list[7]+$list[9]+$list[11];
	$check=(10 - ((3*$oddsum+$evensum)%10))%10; 
	
	return $check;
}


//-----------------takes a data string of 12 digits and returns the corresponding EAN-13/UPC-A symbol using EAN13.ttf-------

function EAN13($data) {
	
	$data=trim($data); // chop spaces, convert string to array
	$list=array();
	
	for ($i=0; $i<12; $i++)	{
		$list[]=substr($data, $i, 1);
	}
	
	$list[]=CheckDigit($list); // append check digit
	
	// offsets for ASCII codes
	$LeftHandA=48;
	$LeftHandB=64;
	$RightHand=80;
	$FirstFlag=33;
	$SecondFlag=96;
	$CheckChar=112;
	$CenterGuard=124;

	// parity patterns for the first five data chars
	$pattern0=array(A,A,A,A,A); 
	$pattern1=array(A,B,A,B,B);
	$pattern2=array(A,B,B,A,B);
	$pattern3=array(A,B,B,B,A);
	$pattern4=array(B,A,A,B,B);
	$pattern5=array(B,B,A,A,B);
	$pattern6=array(B,B,B,A,A);
	$pattern7=array(B,A,B,A,B);
	$pattern8=array(B,A,B,B,A);
	$pattern9=array(B,B,A,B,A);
	
	$LeftHandPattern=array($pattern0, $pattern1, $pattern2, $pattern3, $pattern4, $pattern5, $pattern6, $pattern7, $pattern8, $pattern9);
	
	$pattern = $LeftHandPattern[$list[0]]; // select parity pattern, depending on the first flag char
	
	$list[0]= chr($FirstFlag+$list[0]);
	$list[1]= chr($SecondFlag+$list[1]);
	$listOffset=2; // first two elements were treated separately
	
	for ($i=2; $i<7; $i++)	{ // loop through pattern, encode first 5 data chars
		switch ($pattern[$i-$listOffset])	{
			
			case 'A':
				$list[$i]= chr($LeftHandA+$list[$i]);
			break;
			
			case 'B':
				$list[$i]= chr($LeftHandB+$list[$i]);
			break;
		}
	}
	
	for ($i=7; $i<12; $i++)	{ // encode right hand data chars
		$list[$i]= chr($RightHand+$list[$i]);
	}
	
	$list[12]= chr($CheckChar+$list[12]); // encode check digit
	
	$barcode=implode($list, ''); // convert array to string
	$barcode=substr($barcode,0,7).chr($CenterGuard).substr($barcode,7,6); // add center guard
	
	return $barcode; // done
	
}

?>


<body>

<form name="ean13" action="ean13.php3" method="post">
	<table border='1' cellspacing='5' cellpadding='5' align='center'>
		<tr>
			<td colspan=2 align='center'><input type='text' name='data' size='12' maxlength='12'></td>  
		</tr>
		<tr>
			<td><input type='reset' value='reset'></td>
			<td><input type='submit' name='create' value='create'></td>
		</tr>
		<tr>
		<tr>
			<td colspan='2' style='font-family: EAN-13; font-size: 48px; height=80px; text-align=center;'>
				<?php
				if (isset($data))	{
					$barcode=EAN13($data);
					echo $barcode;
				}
				?>
			</td>
		</tr>	
	</table>
</form>

</body>
</html>
